/*****************/
/* NandemoP6FDSR */
/*****************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "p6fdbootsr.c"
#include "p6fdpatch.c"

#define	MAXFILE	200
#define	MAXLEN	1024
#define	FILELEN	128
#define	MAXINFO	0x1700

#define	MAXFILELEN	0x04e000

typedef struct menuinfo_s {
	unsigned char menudata[MAXINFO+0x100];
	int		menuptr;
	int		menucnt;
	int		datalen;
} menu_s;

typedef struct fileinfo_s {
	unsigned char file_p6[FILELEN];
	unsigned char file_cmd[FILELEN];
	int		filelen;
} file_s;

void make_title(menu_s *, unsigned char *);
void make_menuinfo(menu_s *, file_s *, unsigned char *);
int str2p6(unsigned char *, unsigned char *);

int main(int argc, char **argv)
{
	FILE	*infp, *outfp, *p6fp;
	int		c,i,j;
	int		dsize,tpt;
	int		tno,sno;
	char	linebuf[MAXLEN];
	int		tflag;
	int		filenum,fileflag;

	menu_s	menuinfo;
	file_s	fileinfo[MAXFILE];

	unsigned char *mdata = menuinfo.menudata;

	if (argc != 3) {
		fprintf(stderr, "Usage: NandemoP6FDSR listfile d88file\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "r")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	menuinfo.menuptr = 0;		/* |C^ */
	menuinfo.menucnt = 0;		/* t@C */
	menuinfo.datalen = 0;		/* ṽt@C */

	menuinfo.menuptr ++;		/* 擪̓t@Ci[ */

	tflag = 0;
	while ( fgets(linebuf, MAXLEN, infp) != NULL) {
		for (i = 0;linebuf[i] != 0x00;i ++) {
			if (linebuf[i] == 0x0a || linebuf[i] == 0x0d) {
				linebuf[i] = 0x00;
			}
		}

		if (linebuf[0] == '#' || linebuf[0] == 0x00) {
			;
		} else {
			if (tflag == 0) {
				make_title(&menuinfo, linebuf);
				tflag = 1;
			} else {
				make_menuinfo(&menuinfo, &fileinfo[menuinfo.menucnt], linebuf);
			}
		}
	}

	menuinfo.menudata[0] = menuinfo.menucnt;

	filenum = 0;
	fileflag = 0;

/* output D88 file */
/* 1DD format      */

/* header */
	for (i = 0; i < 27; i ++) {
		fputc(0,outfp);
	}

	fputc(0x10,outfp);	/* 1DD */

/* disk size (4 bytes) */
/* header 0x2b0 */
/* track#0x00-0x4f (0x10+0x100) * 0x10 */

	dsize = 0x2b0 + 0x10 * 0x110 * 80;

	fputc(  (dsize & 0x000000ff)      ,outfp);
	fputc( ((dsize & 0x0000ff00)>> 8) ,outfp);
	fputc( ((dsize & 0x00ff0000)>>16) ,outfp);
	fputc( ((dsize & 0xff000000)>>24) ,outfp);

/* track data table (164 * 4 bytes) */

	tpt = 0x2b0;

	for (i = 0; i < 160; i += 2) {
		fputc(  (tpt & 0x000000ff)      ,outfp);
		fputc( ((tpt & 0x0000ff00)>> 8) ,outfp);
		fputc( ((tpt & 0x00ff0000)>>16) ,outfp);
		fputc( ((tpt & 0xff000000)>>24) ,outfp);
		fputc(0,outfp);
		fputc(0,outfp);
		fputc(0,outfp);
		fputc(0,outfp);
		tpt += (0x10 * 0x110);
	}

	for (; i < 164; i++) {
		fputc(0,outfp);
		fputc(0,outfp);
		fputc(0,outfp);
		fputc(0,outfp);
	}

	for (tno = 0; tno < 80; tno ++) {

/* header */
		for (sno = 1; sno < 17; sno ++) {
			fputc(tno,outfp);	// C
			fputc(0,outfp);		// H
			fputc(sno,outfp);	// R
			fputc(1,outfp);		// N
			fputc(16,outfp);	// sector number
			fputc(0,outfp);		// sector number
			fputc(0,outfp);		// MFM
			fputc(0,outfp);		// normal data
			fputc(0,outfp);		// status normal
			fputc(0,outfp);		// reserved
			fputc(0,outfp);		// reserved
			fputc(0,outfp);		// reserved
			fputc(0,outfp);		// reserved
			fputc(0,outfp);		// reserved
			fputc(0,outfp);		// sector size
			fputc(1,outfp);		// sector size


			if (tno == 0) {

/* track#0 sector#1-#8 : p6fdboot[] */
				if (1 <= sno && sno < 9) {
					for (j = 0; j < 256; j ++ ) {
						fputc(*p6fdbootsr,outfp);
						p6fdbootsr ++;
					}

/* track#0 sector#9-#9 : p6fdpatch[] */
				} else if (9 <= sno && sno < 10) {
					for (j = 0; j < 256; j ++ ) {
						fputc(*p6fdpatch,outfp);
						p6fdpatch ++;
					}
				}
			}

			if ( (tno == 0 && 10 <= sno) || tno == 1) {

/* track#0 sector#10-#16, track#1 sector#1-#16 : menuinfo[] */
				for (j = 0; j < 256; j ++ ) {
					if (menuinfo.menuptr > 0) {
						fputc(*mdata,outfp);
						mdata ++;
						menuinfo.menuptr --;
					} else {
						fputc(0xff,outfp);
					}
				}
			}

			if (tno >= 2) {

				for (j = 0; j < 256; ) {
					switch (fileflag) {
						case 0:
							if ((p6fp = fopen(fileinfo[filenum].file_cmd, "rb")) == NULL) {
								perror(fileinfo[filenum].file_cmd);
								exit(1);
							}
							fileflag = 1;
							break;
						case 1:
							c = fgetc(p6fp);
							if (c == EOF) {
								fileflag = 2;
								fclose(p6fp);
							} else {
								fputc(c,outfp);
								j ++;
								fileinfo[filenum].filelen --;
							}
							break;
						case 2:
							if ((p6fp = fopen(fileinfo[filenum].file_p6, "rb")) == NULL) {
								perror(fileinfo[filenum].file_p6);
								exit(1);
							}
							fileflag = 3;
							break;
						case 3:
							c = fgetc(p6fp);
							if (c == EOF) {
								fileflag = 4;
								fclose(p6fp);
							} else {
								fputc(c,outfp);
								j ++;
								fileinfo[filenum].filelen --;
							}
							break;
						default:
								fputc(0xff,outfp);
								j ++;
							break;
					}

				}
				if (fileinfo[filenum].filelen == 0) {
					filenum ++;
					if (filenum < menuinfo.menucnt) {
						fileflag = 0;
					} else {
						filenum --;
					}
				}

			}
		}
	}

	fclose(outfp);
	fclose(infp);


	return(0);
}

void make_title(menu_s *menuinfo, unsigned char *linebuf)
{
	unsigned char *lox_s;
	unsigned char *loy_s;
	unsigned char *mes_s;
	unsigned char mes_p6[MAXLEN];

	int		lox,loy;
	int		meslen;

	if (strcmp(linebuf,"autostart") == 0) {
														/* j[IȂ */
		menuinfo->menudata[menuinfo->menuptr] = 0xff;
		menuinfo->menuptr ++;
		menuinfo->menudata[menuinfo->menuptr] = 0xff;
		menuinfo->menuptr ++;
		menuinfo->menudata[menuinfo->menuptr] = 0x00;
		menuinfo->menuptr ++;

	} else {
		if ( (lox_s = strtok(linebuf,",")) == NULL) {
			fprintf(stderr,"Title command error!\n");
			fprintf(stderr,"%s\n",linebuf);
			exit(1);
		}
		if ( (loy_s = strtok(NULL,",")) == NULL) {
			fprintf(stderr,"Title command error!\n");
			fprintf(stderr,"%s\n",linebuf);
			exit(1);
		}
		if ( (mes_s = strtok(NULL,",")) == NULL) {
			fprintf(stderr,"Title command error!\n");
			fprintf(stderr,"%s\n",linebuf);
			exit(1);
		}

		lox = atoi(lox_s);
		loy = atoi(loy_s);
		meslen = str2p6(mes_p6, mes_s);

		menuinfo->menudata[menuinfo->menuptr] = lox;
		menuinfo->menuptr ++;
		menuinfo->menudata[menuinfo->menuptr] = loy;
		menuinfo->menuptr ++;

		strcpy(&menuinfo->menudata[menuinfo->menuptr], mes_p6);
		menuinfo->menuptr += meslen;
	}
	return;
}


void make_menuinfo(menu_s *menuinfo, file_s *fileinfo, unsigned char *linebuf)
{
	unsigned char *file_p6;
	unsigned char *file_cmd;
	unsigned char *mes_s;
	unsigned char mes_p6[MAXLEN];
	FILE	*tmpfp;
	int		meslen;
	long int	file_p6_len,file_cmd_len,filelen;

	if ( (file_p6 = strtok(linebuf,",")) == NULL) {
		fprintf(stderr,"File command error!\n");
		fprintf(stderr,"%s\n",linebuf);
		exit(1);
	}
	if ( (file_cmd = strtok(NULL,",")) == NULL) {
		fprintf(stderr,"File command error!\n");
		fprintf(stderr,"%s\n",linebuf);
		exit(1);
	}
	if ( (mes_s = strtok(NULL,",")) == NULL) {
		fprintf(stderr,"File command error!\n");
		fprintf(stderr,"%s\n",linebuf);
		exit(1);
	}


/* t@CJ */

	if ((tmpfp = fopen(file_cmd, "rb")) == NULL) {
		perror(file_cmd);
		exit(1);
	}

	fseek(tmpfp, 0L, SEEK_END);
	file_cmd_len = ftell(tmpfp);
	fclose(tmpfp);

	if ((tmpfp = fopen(file_p6, "rb")) == NULL) {
		perror(file_p6);
		exit(1);
	}

	fseek(tmpfp, 0L, SEEK_END);
	file_p6_len = ftell(tmpfp);
	fclose(tmpfp);

	filelen = ( (file_cmd_len + file_p6_len + 0x0000ff) & 0xffff00);

	strcpy(fileinfo->file_p6,  file_p6);
	strcpy(fileinfo->file_cmd, file_cmd);
	fileinfo->filelen = file_cmd_len + file_p6_len;

	menuinfo->menudata[menuinfo->menuptr] = ((menuinfo->datalen & 0x000f00) >> 8);	// ZN^ԍ-1
	menuinfo->menuptr ++;
	menuinfo->menudata[menuinfo->menuptr] = ((menuinfo->datalen & 0x0ff000) >> 12);	// gbNԍ
	menuinfo->menuptr ++;

	menuinfo->datalen += filelen;
	if (menuinfo->datalen > MAXFILELEN) {
		fprintf(stderr,"Disk Full!\n");
		exit(1);
	}

	meslen = str2p6(mes_p6, mes_s);

	strcpy(&menuinfo->menudata[menuinfo->menuptr], mes_p6);
	menuinfo->menuptr += meslen;
	menuinfo->menucnt ++;

	if (menuinfo->menucnt >= MAXFILE) {
		fprintf(stderr,"Too many files!\n");
		exit(1);
	}

	if (menuinfo->menuptr >= MAXINFO) {
		fprintf(stderr,"Too many data!\n");
		exit(1);
	}

	return;
}


int str2p6(unsigned char *dist, unsigned char *src)
{
	unsigned char marktbl[] = {
		0x20,0xA4,0xA1,0x2C,0x2E,0xA5,0x3A,0x3B,	// 0x8140` @ABCDEFG
		0x3F,0x21,0xDE,0xDF,0x27,0x27,0x00,0x5E,	// 0x8148` HIJKLMNO
		0x7E,0x5F,0x00,0x00,0x00,0x00,0x00,0x00,	// 0x8150` PQRSTUVW
		0x00,0x00,0x00,0xB0,0xB0,0x2D,0x2F,0x5C,	// 0x8158` XYZ[\]^_
		0x7E,0x00,0x7C,0x00,0x00,0x27,0x27,0x22,	// 0x8160` `abcdefg
		0x22,0x28,0x29,0x5B,0x5D,0x5B,0x5D,0x7B,	// 0x8168` hijklmno
		0x7D,0x3C,0x3E,0x3C,0x3E,0xA2,0xA3,0xA2,	// 0x8170` pqrstuvw
		0xA3,0x5B,0x5D,0x2B,0x2D,0x00,0x2A,0x00,	// 0x8178` xyz{|}~
		0x2F,0x3D,0x00,0x3C,0x3E,0x00,0x00,0x00,	// 0x8180` 
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5C,	// 0x8188` 
		0x24,0x00,0x00,0x25,0x23,0x26,0x2A,0x40,	// 0x8190` 
		0x00,0x82,0x82,0x84,0x85,0x00,0x83,0x83,	// 0x8198` 
		0x00,0x00,0x80,0x80,0x81,0x81,0x00,0x00,	// 0x81a0` 
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00		// 0x81a8` 
	};

	unsigned char kanatbl[] = {
													// Ђ炪ȁF0x829f`0x82f1
													// J^JiF0x8340`0x8396
		0x87,0x00,0x91,0x00,0x88,0x00,0x92,0x00,	// 
		0x89,0x00,0x93,0x00,0x8A,0x00,0x94,0x00,	// 
		0x8B,0x00,0x95,0x00,						// 
		0x96,0x00,0x96,0xDE,0x97,0x00,0x97,0xDE,	// 
		0x98,0x00,0x98,0xDE,0x99,0x00,0x99,0xDE,	// 
		0x9A,0x00,0x9A,0xDE,						// 
		0x9B,0x00,0x9B,0xDE,0x9C,0x00,0x9C,0xDE,	// 
		0x9D,0x00,0x9D,0xDE,0x9E,0x00,0x9E,0xDE,	// 
		0x9F,0x00,0x9F,0xDE,						// 
		0xE0,0x00,0xE0,0xDE,0xE1,0x00,0xE1,0xDE,	// 
		0x8F,0x00,									// 
		0xE2,0x00,0xE2,0xDE,0xE3,0x00,0xE3,0xDE,	// ÂĂ
		0xE4,0x00,0xE4,0xDE,						// Ƃ
		0xE5,0x00,0xE6,0x00,0xE7,0x00,0xE8,0x00,	// Ȃɂʂ
		0xE9,0x00,									// 
		0xEA,0x00,0xEA,0xDE,0xEA,0xDF,				// ͂΂
		0xEB,0x00,0xEB,0xDE,0xEB,0xDF,				// Ђт
		0xEC,0x00,0xEC,0xDE,0xEC,0xDF,				// ӂԂ
		0xED,0x00,0xED,0xDE,0xED,0xDF,				// ւׂ
		0xEE,0x00,0xEE,0xDE,0xEE,0xDF,				// قڂ
		0xEF,0x00,0xF0,0x00,0xF1,0x00,0xF2,0x00,	// ܂݂ނ
		0xF3,0x00,									// 
		0x8C,0x00,0xF4,0x00,0x8D,0x00,0xF5,0x00,	// 
		0x8E,0x00,0xF6,0x00,						// 
		0xF7,0x00,0xF8,0x00,0xF9,0x00,0xFA,0x00,	// 
		0xFB,0x00,									// 
		0x00,0x00,0xFC,0x00,0x00,0x00,0x00,0x00,	// 
		0x86,0x00,0xFD,0x00,0x93,0xDE,				// 
		0x00,0x00,0x00,0x00							// 
	};

	unsigned char dt1,dt2;
	unsigned char *dist_o;

	dist_o = dist;

	for (;;) {
		if (0x00 == *src) {
			*dist = '\0';
			dist ++;
			break;
		} else if ( (0x20 <= *src && *src < 0x7f) ||
			 (0xa1 <= *src && *src < 0xdf) ) {
			*dist = *src;
			dist ++;
			src ++;

		} else if (0x81 == *src) {	// L
			src ++;
			if (0x40 <= *src && *src < 0xb0) {
				dt1 = marktbl[*src-0x40];
				if (dt1 == 0x00) {
					dt1 = ' ';
				}
				*dist = dt1;
				dist ++;
				src ++;
			} else {
				*dist = ' ';
				dist ++;
				src ++;
			}

		} else if (0x82 == *src) {	// pAЂ炪
			src ++;
			if (0x4f <= *src && *src < 0x59) {
				*dist = *src-0x4f+'0';
				dist ++;
				src ++;
			} else if (0x60 <= *src && *src < 0x7a) {
				*dist = *src-0x60+'A';
				dist ++;
				src ++;
			} else if (0x81 <= *src && *src < 0x9b) {
				*dist = *src-0x81+'a';
				dist ++;
				src ++;
			} else if (0x9f <= *src && *src < 0xf2) {
				dt1 = kanatbl[(*src-0x9f)*2+0];
				dt2 = kanatbl[(*src-0x9f)*2+1];
				if (dt1 == 0x00) {
					*dist = ' ';
					dist ++;
					src ++;
				} else if (dt2 == 0x00) {
					*dist = dt1;
					dist ++;
					src ++;
				} else {
					*dist = dt1;
					dist ++;
					*dist = dt2;
					dist ++;
					src ++;
				}
			} else {
				*dist = ' ';
				dist ++;
				src ++;
			}

		} else if (0x83 == *src) {	// J^Ji
			src ++;
			if (0x40 <= *src && *src < 0x97) {
				if (0x80 <= *src && *src < 0x97) {
					dt1 = kanatbl[(*src-0x40-1)*2+0];
					dt2 = kanatbl[(*src-0x40-1)*2+1];
				} else {
					dt1 = kanatbl[(*src-0x40)*2+0];
					dt2 = kanatbl[(*src-0x40)*2+1];
				}
				if (dt1 == 0x00) {
					*dist = ' ';
					dist ++;
					src ++;
				} else if (dt2 == 0x00) {
					*dist = (dt1 ^ 0x20);
					dist ++;
					src ++;
				} else {
					*dist = (dt1 ^ 0x20);
					dist ++;
					*dist = dt2;
					dist ++;
					src ++;
				}
			} else {
				*dist = ' ';
				dist ++;
				src ++;
			}

		} else {
			*dist = ' ';
			dist ++;
			src ++;
		}
	}

	return dist - dist_o;
}

