/**********************/
/* binary to C-source */
/**********************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	S_LEN	32

int main(int argc, char **argv)
{
	FILE	*infp, *outfp;
	char	file_bin[S_LEN],file_c[S_LEN];
	int		c;
	long int	file_len,i;

	if (argc != 2) {
		fprintf(stderr, "Usage: convbin filename\n");
		exit(1);
	}

/* open files */

	strncpy(file_bin, argv[1], S_LEN);
	strncpy(file_c  , argv[1], S_LEN);

	strncat(file_bin, ".bin", S_LEN);
	strncat(file_c  , ".c"  , S_LEN);

	if ((infp = fopen(file_bin, "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(file_c, "w")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	fseek(infp, 0L, SEEK_END);
	file_len = ftell(infp);
	fseek(infp, 0L, SEEK_SET);

	fprintf(outfp,"\nunsigned char %s_d[] = {\n",argv[1]);

	i = 0L;
	while ( (c = fgetc(infp)) != EOF) {
		if ( (i % 8) == 0) {
			fprintf(outfp, "\t");
		}

		fprintf(outfp, "0x%02x",c);
		if (i != file_len-1) {
			fprintf(outfp, ",");
		}

		if ( (i % 8) == 7) {
			fprintf(outfp, "\n");
		}
		i ++;
	}

	fprintf(outfp,"};\n");
	fprintf(outfp,"\nunsigned char *%s = %s_d;\n",argv[1],argv[1]);

	fclose(outfp);
	fclose(infp);


	return(0);
}
